## TODO: Separate by time aggregation
## TODO: Build a default path that accounts for:
## variable, system, reference, start date and region name

get_dir <- function(recipe, agg = "global") {
  # This function builds the path for the output directory. The output
  # directories will be subdirectories within outdir, organized by variable,
  # startdate, and aggregation.

  ## TODO: Get aggregation from recipe
  outdir <- recipe$Run$output_dir
  ## TODO: multivar case
  variable <- recipe$Analysis$Variables$name
  system <- gsub('.','', recipe$Analysis$Datasets$System$name, fixed = T)

  if (tolower(recipe$Analysis$Output_format) == 'scorecards') {
    # Define output dir name accordint to Scorecards format
    dict <- read_yaml("conf/output_dictionaries/scorecards.yml")
    # system <- dict$System[[recipe$Analysis$Datasets$System$name]]$short_name
    dir <- paste0(outdir, "/", system, "/", variable, "/")
  } else {
    # Default generic output format based on FOCUS
    # Get startdate or hindcast period
    if (!is.null(recipe$Analysis$Time$fcst_year)) {
      if (tolower(recipe$Analysis$Horizon) == 'decadal') {
        # decadal doesn't have sdate
        fcst.sdate <- paste0(recipe$Analysis$Time$fcst_year, collapse = '_')
      } else {
        fcst.sdate <- paste0(recipe$Analysis$Time$fcst_year,
			     recipe$Analysis$Time$sdate)
      }
    } else {
      if (tolower(recipe$Analysis$Horizon) == 'decadal') {
        # decadal doesn't have sdate
        fcst.sdate <- paste0("hcst-", paste(recipe$Analysis$Time$hcst_start,
					    recipe$Analysis$Time$hcst_end,
					    sep = '_'))
      } else {
        fcst.sdate <- paste0("hcst-", recipe$Analysis$Time$sdate)
      }
    }
  
    calib.method <- tolower(recipe$Analysis$Workflow$Calibration$method)
    store.freq <- recipe$Analysis$Variables$freq
    ## TODO: Change "_country"
    switch(tolower(agg),
  	 "country" = {dir <- paste0(outdir, "/", system, "/", calib.method,
				    "-", store.freq, "/", variable, 
  	             		    "_country/", fcst.sdate, "/")},
  	 "global" = {dir <- paste0(outdir, "/", system, "/", calib.method,
				   "-", store.freq, "/", variable, "/",
				   fcst.sdate, "/")})
  }
  ## TODO: Multivar case
  dir.create(dir, showWarnings = FALSE, recursive = TRUE)
  return(dir)
}
